; compiler          : jal 00.04-50
; date              : 13-Feb-2003 18:25:09
; main source       : kvf
; command line      : kvf.jal 
; target  chip      : 16f84
;         cpu       : pic 14
;         clock     : 4000000
; input   files     : 11
;         lines     : 2585
;         chars     : 62989
; compilation nodes : 17361
;             stack : 53Kb
;              heap : 5678Kb
;           seconds : 1.209 (2138 lines/second)
; output       code :  875
;              page :    0 (0.0%)
;              bank :    0 (0.0%)
;         page+bank :    0 (0.0%)
;              file :   38
;              stack:    4 (4,0,0)

 errorlevel -306
 list p=PIC16f84

_CP_OFF    equ H'3FF0' ;code protect on
_CP_ON     equ H'0000' ;code protect off
_PWRTE_ON  equ H'0000' ;Power on timer on
_PWRTE_OFF equ H'0008' ;Power on timer off
_WDT_OFF   equ H'0000' ;watch dog timer off
_WDT_ON    equ H'0004' ;watch dog timer on
_RC_OSC    equ H'0003' ;RC oscillator
_HS_OSC    equ H'0002' ;HS crystal oscillator
_XT_OSC    equ H'0001' ;XT crystal oscillator
_LP_OSC    equ H'0000' ;LP crystal oscillator

 __CONFIG _CP_OFF + _PWRTE_ON + _WDT_OFF + _XT_OSC 

 ORG 0000
  goto    __main
 ORG 0004
 ORG 0004
__interrupt: ; 0004
__main: ; 0004
; var H'00C:000'  transfer_bit
; var H'00C:000'  transfer_byte

;; 040 : var volatile byte status       at  3
; var H'003:000' status

;; 042 : var volatile byte port_a       at  5
; var H'005:000' port_a

;; 043 : var volatile byte port_b       at  6
; var H'006:000' port_b

;; 047 : var volatile byte x84_eedata   at  8
; var H'008:000' x84_eedata

;; 048 : var volatile byte x84_eeadr    at  9
; var H'009:000' x84_eeadr

;; 086 : var volatile bit  pin_a0 at port_a : 0
; var H'005:000' pin_a0

;; 087 : var volatile bit  pin_a1 at port_a : 1
; var H'005:001' pin_a1

;; 088 : var volatile bit  pin_a2 at port_a : 2
; var H'005:002' pin_a2

;; 097 : var volatile bit  pin_b4 at port_b : 4
; var H'006:004' pin_b4

;; 130 : var volatile bit  status_rp0  at status : 5
; var H'003:005' status_rp0

;; 276 : var byte trisa
; var H'00D:000' trisa

;; 277 : var byte trisb
; var H'00E:000' trisb

;; 284 : trisa = all_input
  movlw   H'FF'
  movwf   H'0D'

;; 286 :    trisb = all_input
  movlw   H'FF'
  movwf   H'0E'

;; 580 : var byte _port_a_buffer
; var H'00F:000' _port_a_buffer

;; 581 : var byte _port_b_buffer
; var H'010:000' _port_b_buffer

;; 011 : pin_a0_direction = input	-- knapp B (mellan)
  bsf     H'0D',0
  call    _3134__vector

;; 012 : pin_a1_direction = input	-- Knapp A (topp)
  bsf     H'0D',1
  call    _3163__vector

;; 013 : pin_a2_direction = input	-- Knapp C (botten = rd)
  bsf     H'0D',2
  call    _3192__vector

;; 014 : pin_a3_direction = output	-- Rd LED	
  bcf     H'0D',3
  call    _3221__vector

;; 015 : pin_a4_direction = output	-- Ej anvnd
  bcf     H'0D',4
  call    _3250__vector

;; 016 : pin_b0_direction = output	-- LED vnster
  bcf     H'0E',0
  call    _3343__vector

;; 017 : pin_b1_direction = output	-- LED hger
  bcf     H'0E',1
  call    _3372__vector

;; 018 : pin_b2_direction = output	-- IR LED 
  bcf     H'0E',2
  call    _3401__vector

;; 019 : pin_b3_direction = output	-- Hgtalare
  bcf     H'0E',3
  call    _3430__vector

;; 020 : pin_b4_direction = input	-- Sensor 
  bsf     H'0E',4
  call    _3459__vector

;; 021 : pin_b5_direction = output	-- Ej anvnd
  bcf     H'0E',5
  call    _3488__vector

;; 022 : pin_b6_direction = input	-- Com in
  bsf     H'0E',6
  call    _3517__vector

;; 023 : pin_b7_direction = output	-- Com ut
  bcf     H'0E',7
  call    _3546__vector

;; 044 : var byte foo  = 0		-- Metasyntaktisk 
; var H'011:000' foo
  clrf    H'11'

;; 045 : var byte bar = 0		-- variabel...
; var H'012:000' bar
  clrf    H'12'

;; 047 : var byte tcont = 0		-- Tidskontroll
; var H'013:000' tcont
  clrf    H'13'

;; 049 : var byte stat = 0		-- Knappar och sensorer
; var H'014:000' stat
  clrf    H'14'

;; 050 : var byte spstat = 0		-- Hgtalarlge
; var H'015:000' spstat
  clrf    H'15'

;; 051 : var byte delstartmain = 0	-- Huvudtid Tid till scanningen brjar (minuter)
; var H'016:000' delstartmain
  clrf    H'16'

;; 052 : var byte delstart = 0		-- 21 r ungefr 1 minut
; var H'017:000' delstart
  clrf    H'17'

;; 054 : var byte signum = 0		-- Antalet signaler som givits under hela perioden
; var H'018:000' signum
  clrf    H'18'

;; 055 : var byte sps = 0		-- Signaler per scan-period
; var H'019:000' sps
  clrf    H'19'

;; 056 : var byte scantime = 180		-- Tid som gat avlses (180 = ca 10 sek)
; var H'01A:000' scantime
  movlw   H'B4'
  movwf   H'1A'

;; 057 : var byte inten = 5		-- Ljusstyrka p IR-diod
; var H'01B:000' inten
  movlw   H'05'
  movwf   H'1B'

;; 058 : var byte aset = 0		-- Markr fr drmalarm
; var H'01C:000' aset
  clrf    H'1C'

;; 059 : var byte act = 0		-- Skarp!
; var H'01D:000' act
  clrf    H'1D'

;; 060 : var byte count = 20		-- Frdrjningsrknare
; var H'01E:000' count
  movlw   H'14'
  movwf   H'1E'

;; 061 : var byte amar = 0		-- Markr fr alarm
; var H'01F:000' amar
  clrf    H'1F'

;; 062 : var byte siglen = 255		-- Lngd p ljusblink
; var H'020:000' siglen
  movlw   H'FF'
  movwf   H'20'

;; 065 : var byte tres = 1		-- Antal signaler per sekund som krvs fr signal
; var H'021:000' tres
  movlw   H'01'
  movwf   H'21'

;; 066 : var byte adelay = 5		-- Drmmalarm tid till aktivering efter signal (minuter)
; var H'022:000' adelay
  movlw   H'05'
  movwf   H'22'

;; 067 : var byte sigen = 10		-- Ljusstyrka p LED
; var H'023:000' sigen
  movlw   H'0A'
  movwf   H'23'

;; 069 : var byte inter = 3		-- Tid mellan blink
; var H'024:000' inter
  movlw   H'03'
  movwf   H'24'

;; 070 : var byte antal = 3		-- Antal blink
; var H'025:000' antal
  movlw   H'03'
  movwf   H'25'

;; 071 : var byte ljud = 0		-- Ljud med ljuset?
; var H'026:000' ljud
  clrf    H'26'

;; 072 : var byte sdel = 15		-- Tid till nsta aktivering om ingen signal
; var H'027:000' sdel
  movlw   H'0F'
  movwf   H'27'

;; 389 : if act == 0 then
  movf    H'1D',f
  btfss   H'03',2
  goto    if_13673_by
if_13673_th: ; 0046

;; 390 : 	pin_b2 = low	-- Stng av IR-LED	
  bcf     H'10',2
  call    _6142__vector

;; 391 : 	pin_a3 = low	-- Stng av rd LED
  bcf     H'0F',3
  call    _5997__vector

;; 392 : 	pin_b0 = low	-- Stng av vnster LED
  bcf     H'10',0
  call    _6084__vector

;; 393 : 	pin_b1 = low	-- Stng av hger LED
  bcf     H'10',1
  call    _6113__vector

;; 394 : 	pin_b3 = low	-- Stng av hgtalare
  bcf     H'10',3
  call    _6171__vector

;; 395 : 	for 3 loop
; var H'028:000' _loop_temp_13705
  movlw   H'03'
  movwf   H'28'
f_13705_again: ; 0052

;; 396 : 		reac
  call    _12231__vector

;; 397 : 		beep	
  call    _12176__vector

  decfsz  H'28',f
  goto    f_13705_again

;; 399 : 	eeprom_get(1,adelay)
  movlw   H'01'
  movwf   H'28'
  call    _6949__vector
  movf    H'29',w
  movwf   H'22'

;; 400 : 	eeprom_get(2,sdel)
  movlw   H'02'
  movwf   H'28'
  call    _6949__vector
  movf    H'29',w
  movwf   H'27'

;; 401 : 	eeprom_get(3,tres)
  movlw   H'03'
  movwf   H'28'
  call    _6949__vector
  movf    H'29',w
  movwf   H'21'

;; 402 : 	eeprom_get(4,ljud)
  movlw   H'04'
  movwf   H'28'
  call    _6949__vector
  movf    H'29',w
  movwf   H'26'

;; 403 : 	eeprom_get(5,sigen)
  movlw   H'05'
  movwf   H'28'
  call    _6949__vector
  movf    H'29',w
  movwf   H'23'

;; 404 : 	eeprom_get(6,inter)
  movlw   H'06'
  movwf   H'28'
  call    _6949__vector
  movf    H'29',w
  movwf   H'24'

;; 405 : 	eeprom_get(7,antal)
  movlw   H'07'
  movwf   H'28'
  call    _6949__vector
  movf    H'29',w
  movwf   H'25'

;; 409 : 	act = 1
  movlw   H'01'
  movwf   H'1D'
if_13673_by: ; 007B

;; 412 : forever loop	-- Huvudloop 
w_14200_ag: ; 007B

;; 413 : 	kkol	-- kolla knapparna
  call    _12024__vector

;; 414 : 	avstuds	-- Studsa av
  call    _12086__vector

;; 415 : 	asm clrwdt
  clrwdt  

;; 417 : 	if stat != 0 then	-- Fixar s att saker och ting inte startar direkt
  movf    H'14',f
  btfsc   H'03',2
  goto    if_13859_el
if_13859_th: ; 0081

;; 418 : 		count = 20
  movlw   H'14'
  movwf   H'1E'
  goto    if_13859_by
if_13859_el: ; 0084

;; 420 : 		if count > 0 then
  movf    H'1E',w
  sublw   H'00'
  btfsc   H'03',0
  goto    if_13873_by
if_13873_th: ; 0088

;; 421 : 			count = count - 1
  movlw   H'01'
  subwf   H'1E',w
  movwf   H'1E'

;; 422 : 			delay_10ms(4)
  movlw   H'04'
  call    _9619__vector

;; 423 : 			lbeep
  call    _12741__vector
if_13873_by: ; 008E
if_13859_by: ; 008E

;; 426 : 	if count == 0 then
  movf    H'1E',f
  btfss   H'03',2
  goto    if_13909_el
if_13909_th: ; 0091

;; 427 : 		act = 2
  movlw   H'02'
  movwf   H'1D'
  goto    if_13909_by
if_13909_el: ; 0094

;; 430 : 		act = 1
  movlw   H'01'
  movwf   H'1D'
if_13909_by: ; 0096

;; 436 : 	if stat == 4 then -- Kr rc och ka tiden 
  movf    H'14',w
  sublw   H'04'
  btfss   H'03',2
  goto    if_13930_by
if_13930_th: ; 009A

;; 437 : 		reac
  call    _12231__vector

;; 438 : 		delstartmain = delstartmain + 10	-- Varje knapptryck kar tiden med 10 minuter
  movlw   H'0A'
  addwf   H'16',f
if_13930_by: ; 009D

;; 442 : 	if stat == 1 then 
  movf    H'14',w
  sublw   H'01'
  btfss   H'03',2
  goto    if_13952_by
if_13952_th: ; 00A1

;; 444 : 	delstartmain = 0
  clrf    H'16'

;; 445 : 	setba	-- G till subrutin	
  call    _12861__vector
if_13952_by: ; 00A3

;; 448 : 	if stat == 2 then
  movf    H'14',w
  sublw   H'02'
  btfss   H'03',2
  goto    if_13972_by
if_13972_th: ; 00A7

;; 449 : 	delstartmain = 0
  clrf    H'16'

;; 450 : 	snum(signum)
  movf    H'18',w
  call    _12280__vector

;; 451 : 	signum = 0
  clrf    H'18'

;; 452 : 	beep
  call    _12176__vector

;; 453 : 	beep
  call    _12176__vector

;; 454 : 	beep		
  call    _12176__vector

;; 455 : 	setbb	-- G till subrutin
  call    _13295__vector
if_13972_by: ; 00AF

;; 460 : 	if act == 2 then
  movf    H'1D',w
  sublw   H'02'
  btfss   H'03',2
  goto    if_14027_by
if_14027_th: ; 00B3

;; 461 : 	if (delstartmain > 0) & (delstart == 0) then	-- Stt upp fr en runda
  movf    H'16',w
  sublw   H'00'
  btfsc   H'03',0
  goto    if_14034_by
e_14040: ; 00B7
  movf    H'17',f
  btfss   H'03',2
  goto    if_14034_by
if_14034_th: ; 00BA

;; 462 : 			delstart = 21	-- Stt upp fr en minut till
  movlw   H'15'
  movwf   H'17'

;; 463 : 			if delstartmain > 0 then
  movf    H'16',w
  sublw   H'00'
  btfsc   H'03',0
  goto    if_14053_by
if_14053_th: ; 00C0

;; 464 : 				delstartmain = delstartmain - 1	-- en runda avklarad
  movlw   H'01'
  subwf   H'16',w
  movwf   H'16'
if_14053_by: ; 00C3
if_14034_by: ; 00C3

;; 467 : 	if (delstart > 0)  then	-- Kr en smn
  movf    H'17',w
  sublw   H'00'
  btfsc   H'03',0
  goto    if_14070_by
if_14070_th: ; 00C7

;; 468 : 			delstart = delstart - 1	-- Krt en
  movlw   H'01'
  subwf   H'17',w
  movwf   H'17'

;; 469 : 			lbeep
  call    _12741__vector

;; 470 : 			sleep
  call    _7523__vector
if_14070_by: ; 00CC

;; 473 : 	if (delstart == 0) & (delstartmain == 0) then	-- Dags att kra en scan om tiden r inne och skarpt lge
  movf    H'17',f
  btfss   H'03',2
  goto    if_14098_by
e_14104: ; 00CF
  movf    H'16',f
  btfss   H'03',2
  goto    if_14098_by
if_14098_th: ; 00D2

;; 474 : 		if amar == 1 then	-- Kr larm!
  movf    H'1F',w
  sublw   H'01'
  btfss   H'03',2
  goto    if_14111_el
if_14111_th: ; 00D6

;; 475 : 			kkol
  call    _12024__vector

;; 476 : 			dral
  call    _12772__vector

;; 477 : 			amar = 0
  clrf    H'1F'

;; 478 : 			delstartmain = adelay	-- stt upp fr ny enligt adelay
  movf    H'22',w
  movwf   H'16'
  goto    if_14111_by
if_14111_el: ; 00DC

;; 480 : 			scan	-- Scanna
  call    _12511__vector

;; 481 : 			if sps > tres then	-- Har vi signaler?
  movf    H'19',w
  subwf   H'21',w
  btfsc   H'03',0
  goto    if_14147_el
if_14147_th: ; 00E1

;; 482 : 				signal		-- Signalera
  call    _12641__vector

;; 483 : 				signum = signum + 1
  incf    H'18',f

;; 484 : 				delstartmain = adelay	-- stt upp fr ny enligt adelay
  movf    H'22',w
  movwf   H'16'

;; 485 : 				if aset == 1 then	-- Skall vi larma nsta gng?
  movf    H'1C',w
  sublw   H'01'
  btfss   H'03',2
  goto    if_14170_el
if_14170_th: ; 00E9

;; 486 : 					amar = 1	-- LArma!
  movlw   H'01'
  movwf   H'1F'
  goto    if_14170_by
if_14170_el: ; 00EC

;; 488 : 					amar = 0
  clrf    H'1F'
if_14170_by: ; 00ED
  goto    if_14147_by
if_14147_el: ; 00EE

;; 492 : 				delstartmain = sdel	-- stt upp fr ny enligt sdel
  movf    H'27',w
  movwf   H'16'
if_14147_by: ; 00F0
if_14111_by: ; 00F0
if_14098_by: ; 00F0
if_14027_by: ; 00F0
  goto    w_14200_ag

;; 003 :   idle_loop: page goto idle_loop
as_14203_idle_loop: ; 00F1
  goto    as_14203_idle_loop
_13295__vector: ; 00F2
p_13295_setbb: ; 00F2

;; 327 : bar = 1
  movlw   H'01'
  movwf   H'12'

;; 328 : barp(1)
  movlw   H'01'
  call    _12817__vector

;; 329 : while stat != 4 loop	
w_13661_ag: ; 00F6
  movf    H'14',w
  sublw   H'04'
  btfsc   H'03',2
w_13661_jb: ; 00F9
  goto    w_13661_be
w_13661_bo: ; 00FA

;; 330 : 	pin_b0 = high
  bsf     H'10',0
  call    _6084__vector

;; 331 : 	kkol
  call    _12024__vector

;; 332 : 	avstuds
  call    _12086__vector

;; 333 : 	asm clrwdt
  clrwdt  

;; 334 : 	if stat == 2 then 
  movf    H'14',w
  sublw   H'02'
  btfss   H'03',2
  goto    if_13345_by
if_13345_th: ; 0103

;; 335 : 		bar = bar + 1
  incf    H'12',f

;; 336 : 		if bar == 6 then
  movf    H'12',w
  sublw   H'06'
  btfss   H'03',2
  goto    if_13360_by
if_13360_th: ; 0108

;; 337 : 			bar = 1
  movlw   H'01'
  movwf   H'12'
if_13360_by: ; 010A

;; 339 : 		barp(bar)
  movf    H'12',w
  call    _12817__vector
if_13345_by: ; 010C

;; 341 : 	if (bar == 1) & (stat == 1) then
  movf    H'12',w
  sublw   H'01'
  btfss   H'03',2
  goto    if_13386_by
e_13392: ; 0110
  movf    H'14',w
  sublw   H'01'
  btfss   H'03',2
  goto    if_13386_by
if_13386_th: ; 0114

;; 342 : 		pin_b0 = low
  bcf     H'10',0
  call    _6084__vector

;; 343 : 		calib
  call    _12406__vector

;; 344 : 		pin_b0 = high
  bsf     H'10',0
  call    _6084__vector
if_13386_by: ; 0119

;; 346 : 	if (bar == 2) & (stat == 1) then
  movf    H'12',w
  sublw   H'02'
  btfss   H'03',2
  goto    if_13416_by
e_13422: ; 011D
  movf    H'14',w
  sublw   H'01'
  btfss   H'03',2
  goto    if_13416_by
if_13416_th: ; 0121

;; 347 : 		pin_b0 = low
  bcf     H'10',0
  call    _6084__vector

;; 348 : 		scan
  call    _12511__vector

;; 349 : 		snum(sps)
  movf    H'19',w
  call    _12280__vector

;; 350 : 		beep
  call    _12176__vector

;; 351 : 		pin_b0 = high
  bsf     H'10',0
  call    _6084__vector

;; 352 : 		bar = 2
  movlw   H'02'
  movwf   H'12'
if_13416_by: ; 012B

;; 354 : 	if (bar == 3) & (stat == 1) then
  movf    H'12',w
  sublw   H'03'
  btfss   H'03',2
  goto    if_13469_by
e_13475: ; 012F
  movf    H'14',w
  sublw   H'01'
  btfss   H'03',2
  goto    if_13469_by
if_13469_th: ; 0133

;; 355 : 		sigen = sigen - 1
  movlw   H'01'
  subwf   H'23',w
  movwf   H'23'

;; 356 : 		if sigen < 1 then
  movlw   H'01'
  subwf   H'23',w
  btfsc   H'03',0
  goto    if_13490_by
if_13490_th: ; 013A

;; 357 : 			sigen = 10
  movlw   H'0A'
  movwf   H'23'
if_13490_by: ; 013C

;; 359 : 		barp(sigen)
  movf    H'23',w
  call    _12817__vector

;; 360 : 		eeprom_put(5,sigen)
  movlw   H'05'
  movwf   H'28'
  movf    H'23',w
  call    _7097__vector
if_13469_by: ; 0142

;; 363 : 	if (bar == 4) & (stat == 1) then
  movf    H'12',w
  sublw   H'04'
  btfss   H'03',2
  goto    if_13533_by
e_13539: ; 0146
  movf    H'14',w
  sublw   H'01'
  btfss   H'03',2
  goto    if_13533_by
if_13533_th: ; 014A

;; 364 : 		inter = inter + 3
  movlw   H'03'
  addwf   H'24',f

;; 365 : 		if inter > 11 then
  movf    H'24',w
  sublw   H'0B'
  btfsc   H'03',0
  goto    if_13554_by
if_13554_th: ; 0150

;; 366 : 			inter = 3
  movlw   H'03'
  movwf   H'24'
if_13554_by: ; 0152

;; 368 : 		barp(inter)
  movf    H'24',w
  call    _12817__vector

;; 369 : 		eeprom_put(6,inter)
  movlw   H'06'
  movwf   H'28'
  movf    H'24',w
  call    _7097__vector
if_13533_by: ; 0158

;; 371 : 	if (bar == 5) & (stat == 1) then
  movf    H'12',w
  sublw   H'05'
  btfss   H'03',2
  goto    if_13597_by
e_13603: ; 015C
  movf    H'14',w
  sublw   H'01'
  btfss   H'03',2
  goto    if_13597_by
if_13597_th: ; 0160

;; 372 : 		antal = antal + 3
  movlw   H'03'
  addwf   H'25',f

;; 373 : 		if antal > 11 then
  movf    H'25',w
  sublw   H'0B'
  btfsc   H'03',0
  goto    if_13618_by
if_13618_th: ; 0166

;; 374 : 			antal = 3
  movlw   H'03'
  movwf   H'25'
if_13618_by: ; 0168

;; 376 : 		eeprom_put(7,antal)
  movlw   H'07'
  movwf   H'28'
  movf    H'25',w
  call    _7097__vector

;; 377 : 		barp(antal)
  movf    H'25',w
  call    _12817__vector
if_13597_by: ; 016E
  goto    w_13661_ag
w_13661_be: ; 016F

;; 380 : pin_b0 = low
  bcf     H'10',0
  goto    _6084__vector
e_13295_setbb: ; 0171
_12861__vector: ; 0171
p_12861_setba: ; 0171

;; 264 : bar = 1
  movlw   H'01'
  movwf   H'12'

;; 265 : barp(1)
  movlw   H'01'
  call    _12817__vector

;; 266 : while stat != 4 loop
w_13283_ag: ; 0175
  movf    H'14',w
  sublw   H'04'
  btfsc   H'03',2
w_13283_jb: ; 0178
  goto    w_13283_be
w_13283_bo: ; 0179

;; 267 : 	pin_b1 = high	
  bsf     H'10',1
  call    _6113__vector

;; 268 : 	kkol
  call    _12024__vector

;; 269 : 	avstuds
  call    _12086__vector

;; 270 : 	asm clrwdt
  clrwdt  

;; 271 : 	if stat == 1 then 
  movf    H'14',w
  sublw   H'01'
  btfss   H'03',2
  goto    if_12911_by
if_12911_th: ; 0182

;; 272 : 		bar = bar + 1
  incf    H'12',f

;; 273 : 		if bar == 6 then
  movf    H'12',w
  sublw   H'06'
  btfss   H'03',2
  goto    if_12926_by
if_12926_th: ; 0187

;; 274 : 			bar = 1
  movlw   H'01'
  movwf   H'12'
if_12926_by: ; 0189

;; 276 : 		barp(bar)
  movf    H'12',w
  call    _12817__vector
if_12911_by: ; 018B

;; 278 : 	if (bar == 1) & (stat == 2) then
  movf    H'12',w
  sublw   H'01'
  btfss   H'03',2
  goto    if_12952_by
e_12958: ; 018F
  movf    H'14',w
  sublw   H'02'
  btfss   H'03',2
  goto    if_12952_by
if_12952_th: ; 0193

;; 279 : 		if aset == 0 then
  movf    H'1C',f
  btfss   H'03',2
  goto    if_12965_el
if_12965_th: ; 0196

;; 280 : 			aset = 1
  movlw   H'01'
  movwf   H'1C'

;; 281 : 			barp(2)
  movlw   H'02'
  call    _12817__vector
  goto    if_12965_by
if_12965_el: ; 019B

;; 283 : 			aset = 0
  clrf    H'1C'

;; 284 : 			barp(1)
  movlw   H'01'
  call    _12817__vector
if_12965_by: ; 019E
if_12952_by: ; 019E

;; 287 : 	if (bar == 2) & (stat == 2) then
  movf    H'12',w
  sublw   H'02'
  btfss   H'03',2
  goto    if_13013_by
e_13019: ; 01A2
  movf    H'14',w
  sublw   H'02'
  btfss   H'03',2
  goto    if_13013_by
if_13013_th: ; 01A6

;; 288 : 		adelay = adelay + 5
  movlw   H'05'
  addwf   H'22',f

;; 289 : 		if adelay > 19 then
  movf    H'22',w
  sublw   H'13'
  btfsc   H'03',0
  goto    if_13034_by
if_13034_th: ; 01AC

;; 290 : 			adelay = 5
  movlw   H'05'
  movwf   H'22'
if_13034_by: ; 01AE

;; 292 : 		eeprom_put(1,adelay)
  movlw   H'01'
  movwf   H'28'
  movf    H'22',w
  call    _7097__vector

;; 294 : 		barp(adelay)
  movf    H'22',w
  call    _12817__vector
if_13013_by: ; 01B4

;; 296 : 	if (bar == 3) & (stat == 2) then
  movf    H'12',w
  sublw   H'03'
  btfss   H'03',2
  goto    if_13077_by
e_13083: ; 01B8
  movf    H'14',w
  sublw   H'02'
  btfss   H'03',2
  goto    if_13077_by
if_13077_th: ; 01BC

;; 297 : 		sdel = sdel + 5
  movlw   H'05'
  addwf   H'27',f

;; 298 : 		if sdel > 34 then
  movf    H'27',w
  sublw   H'22'
  btfsc   H'03',0
  goto    if_13098_by
if_13098_th: ; 01C2

;; 299 : 			sdel = 5
  movlw   H'05'
  movwf   H'27'
if_13098_by: ; 01C4

;; 301 : 		eeprom_put(2,sdel)
  movlw   H'02'
  movwf   H'28'
  movf    H'27',w
  call    _7097__vector

;; 302 : 		barp(sdel)
  movf    H'27',w
  call    _12817__vector
if_13077_by: ; 01CA

;; 304 : 	if (bar == 4) & (stat == 2) then
  movf    H'12',w
  sublw   H'04'
  btfss   H'03',2
  goto    if_13141_by
e_13147: ; 01CE
  movf    H'14',w
  sublw   H'02'
  btfss   H'03',2
  goto    if_13141_by
if_13141_th: ; 01D2

;; 305 : 		tres = tres + 1
  incf    H'21',f

;; 306 : 		if tres > 10 then
  movf    H'21',w
  sublw   H'0A'
  btfsc   H'03',0
  goto    if_13162_by
if_13162_th: ; 01D7

;; 307 : 			tres = 1
  movlw   H'01'
  movwf   H'21'
if_13162_by: ; 01D9

;; 309 : 		eeprom_put(3,tres)
  movlw   H'03'
  movwf   H'28'
  movf    H'21',w
  call    _7097__vector

;; 310 : 		barp(tres)
  movf    H'21',w
  call    _12817__vector
if_13141_by: ; 01DF

;; 312 : 	if (bar == 5) & (stat == 2) then
  movf    H'12',w
  sublw   H'05'
  btfss   H'03',2
  goto    if_13205_by
e_13211: ; 01E3
  movf    H'14',w
  sublw   H'02'
  btfss   H'03',2
  goto    if_13205_by
if_13205_th: ; 01E7

;; 313 : 		if ljud == 0 then
  movf    H'26',f
  btfss   H'03',2
  goto    if_13218_el
if_13218_th: ; 01EA

;; 314 : 			ljud = 1
  movlw   H'01'
  movwf   H'26'

;; 315 : 			barp(2)
  movlw   H'02'
  call    _12817__vector
  goto    if_13218_by
if_13218_el: ; 01EF

;; 317 : 			ljud = 0
  clrf    H'26'

;; 318 : 			barp(1)
  movlw   H'01'
  call    _12817__vector
if_13218_by: ; 01F2

;; 320 : 		eeprom_put(4,ljud)
  movlw   H'04'
  movwf   H'28'
  movf    H'26',w
  call    _7097__vector
if_13205_by: ; 01F6
  goto    w_13283_ag
w_13283_be: ; 01F7

;; 323 : pin_b1 = low
  bcf     H'10',1
  goto    _6113__vector
e_12861_setba: ; 01F9
_12817__vector: ; 01F9

;; 255 : procedure barp(byte in foo) is
; var H'028:000' foo
p_12817_barp: ; 01F9
  movwf   H'28'

;; 256 : 	for foo loop
; var H'029:000' _loop_temp_12831
  movf    H'28',w
  movwf   H'29'
w_14745_ag: ; 01FC
  movf    H'29',f
  btfsc   H'03',2
w_14745_jb: ; 01FE
  goto    w_14745_be
w_14745_bo: ; 01FF

;; 257 : 		beep
  call    _12176__vector

;; 258 : 		asm clrwdt
  clrwdt  

;; 259 : 		delay_100ms(1)
  movlw   H'01'
  call    _9754__vector

  decf    H'29',f
  goto    w_14745_ag
w_14745_be: ; 0205
e_12817_barp: ; 0205
  return  
_12772__vector: ; 0206
p_12772_dral: ; 0206

;; 246 : kkol
  call    _12024__vector

;; 247 : while stat == 0 loop
w_12804_ag: ; 0207
  movf    H'14',f
  btfss   H'03',2
w_12804_jb: ; 0209
  goto    w_12804_be
w_12804_bo: ; 020A

;; 248 : 	kkol
  call    _12024__vector

;; 249 : 	reac
  call    _12231__vector

;; 250 : 	asm clrwdt
  clrwdt  
  goto    w_12804_ag
w_12804_be: ; 020E

;; 252 : avstuds
  goto    _12086__vector
e_12772_dral: ; 020F
_12741__vector: ; 020F
p_12741_lbeep: ; 020F

;; 239 : pin_a3 = high
  bsf     H'0F',3
  call    _5997__vector

;; 459 : procedure delay_100ms( byte in x = 1 ) is
  movlw   H'01'

;; 240 : delay_100ms
  call    _9754__vector

;; 241 : pin_a3 = low
  bcf     H'0F',3
  goto    _5997__vector
e_12741_lbeep: ; 0215
_12641__vector: ; 0215
p_12641_signal: ; 0215

;; 213 : foo = 10 - sigen
  movf    H'23',w
  sublw   H'0A'
  movwf   H'11'

;; 214 : for antal loop
; var H'028:000' _loop_temp_12655
  movf    H'25',w
  movwf   H'28'
w_14718_ag: ; 021A
  movf    H'28',f
  btfsc   H'03',2
w_14718_jb: ; 021C
  goto    w_14718_be
w_14718_bo: ; 021D

;; 215 : 	for siglen loop
; var H'029:000' _loop_temp_12659
  movf    H'20',w
  movwf   H'29'
w_14676_ag: ; 021F
  movf    H'29',f
  btfsc   H'03',2
w_14676_jb: ; 0221
  goto    w_14676_be
w_14676_bo: ; 0222

;; 216 : 		for sigen loop	-- Loopa tnd XXX Detta stycke stter ljusstyrkan XXX
; var H'02A:000' _loop_temp_12663
  movf    H'23',w
  movwf   H'2A'
w_14634_ag: ; 0224
  movf    H'2A',f
  btfsc   H'03',2
w_14634_jb: ; 0226
  goto    w_14634_be
w_14634_bo: ; 0227

;; 217 : 			pin_b0 = high	-- Stt p 
  bsf     H'10',0
  call    _6084__vector

;; 218 : 			pin_b1 = high
  bsf     H'10',1
  call    _6113__vector

  decf    H'2A',f
  goto    w_14634_ag
w_14634_be: ; 022D

;; 220 : 		for foo loop	-- Loopa slck
; var H'02A:000' _loop_temp_12677
  movf    H'11',w
  movwf   H'2A'
w_14661_ag: ; 022F
  movf    H'2A',f
  btfsc   H'03',2
w_14661_jb: ; 0231
  goto    w_14661_be
w_14661_bo: ; 0232

;; 221 : 			pin_b0 = low	-- Slck 
  bcf     H'10',0
  call    _6084__vector

;; 222 : 			pin_b1 = low	
  bcf     H'10',1
  call    _6113__vector

  decf    H'2A',f
  goto    w_14661_ag
w_14661_be: ; 0238

;; 224 : 		asm clrwdt
  clrwdt  

  decf    H'29',f
  goto    w_14676_ag
w_14676_be: ; 023B

;; 226 : 	pin_b0 = low	-- Slck 
  bcf     H'10',0
  call    _6084__vector

;; 227 : 	pin_b1 = low	
  bcf     H'10',1
  call    _6113__vector

;; 228 : 	if ljud == 1 then
  movf    H'26',w
  sublw   H'01'
  btfsc   H'03',2
if_12703_th: ; 0242

;; 229 : 		beep
  call    _12176__vector
if_12703_by: ; 0243

;; 231 : 	for inter loop
; var H'029:000' _loop_temp_12717
  movf    H'24',w
  movwf   H'29'
w_14703_ag: ; 0245
  movf    H'29',f
  btfsc   H'03',2
w_14703_jb: ; 0247
  goto    w_14703_be
w_14703_bo: ; 0248

;; 232 : 		asm clrwdt
  clrwdt  

;; 233 : 		delay_100ms(1)
  movlw   H'01'
  call    _9754__vector

  decf    H'29',f
  goto    w_14703_ag
w_14703_be: ; 024D
  decf    H'28',f
  goto    w_14718_ag
w_14718_be: ; 024F
e_12641_signal: ; 024F
  return  
_12511__vector: ; 0250
p_12511_scan: ; 0250

;; 182 : foo = 10 - inten	-- foo r slckt tid
  movf    H'1B',w
  sublw   H'0A'
  movwf   H'11'

;; 183 : bar = 0			-- temporrt tillstnd
  clrf    H'12'

;; 184 : sps = 0			-- Signaler under denna scanning
  clrf    H'19'

;; 185 : pin_a3 = high
  bsf     H'0F',3
  call    _5997__vector

;; 186 : for scantime loop
; var H'028:000' _loop_temp_12542
  movf    H'1A',w
  movwf   H'28'
w_14595_ag: ; 0259
  movf    H'28',f
  btfsc   H'03',2
w_14595_jb: ; 025B
  goto    w_14595_be
w_14595_bo: ; 025C

;; 187 : asm clrwdt
  clrwdt  

;; 188 : for 255 loop
; var H'029:000' _loop_temp_12548
  movlw   H'FF'
  movwf   H'29'
f_12548_again: ; 025F

;; 190 : 	for inten loop	-- Loopa tnd XXX Detta stycke stter ljusstyrkan XXX
; var H'02A:000' _loop_temp_12554
  movf    H'1B',w
  movwf   H'2A'
w_14544_ag: ; 0261
  movf    H'2A',f
  btfsc   H'03',2
w_14544_jb: ; 0263
  goto    w_14544_be
w_14544_bo: ; 0264

;; 191 : 		pin_b2 = high	-- Stt p IR
  bsf     H'10',2
  call    _6142__vector

  decf    H'2A',f
  goto    w_14544_ag
w_14544_be: ; 0268

;; 193 : 	if (pin_b4 == high) & (bar == 0) then
  movf    H'12',f
  btfss   H'03',2
  goto    if_12563_by
e_12568: ; 026B
  btfss   H'06',4
  goto    if_12563_by
if_12563_th: ; 026D

;; 194 : 		bar = 1 
  movlw   H'01'
  movwf   H'12'

;; 195 : 		sps = sps + 1
  incf    H'19',f
if_12563_by: ; 0270

;; 197 : 	if (pin_b4 == low) & (bar == 1) then
  btfsc   H'06',4
  goto    if_12590_by
e_12595: ; 0272
  movf    H'12',w
  sublw   H'01'
  btfss   H'03',2
  goto    if_12590_by
if_12590_th: ; 0276

;; 198 : 		bar = 0
  clrf    H'12'

;; 199 : 		sps = sps + 1
  incf    H'19',f
if_12590_by: ; 0278

;; 201 : 	for foo loop	-- Loopa slck
; var H'02A:000' _loop_temp_12617
  movf    H'11',w
  movwf   H'2A'
w_14565_ag: ; 027A
  movf    H'2A',f
  btfsc   H'03',2
w_14565_jb: ; 027C
  goto    w_14565_be
w_14565_bo: ; 027D

;; 202 : 		pin_b2 = low	-- Slck IR
  bcf     H'10',2
  call    _6142__vector

  decf    H'2A',f
  goto    w_14565_ag
w_14565_be: ; 0281
  decfsz  H'29',f
  goto    f_12548_again
  decf    H'28',f
  goto    w_14595_ag
w_14595_be: ; 0285

;; 208 : pin_b2 = low
  bcf     H'10',2
  call    _6142__vector

;; 209 : pin_a3 = low
  bcf     H'0F',3
  goto    _5997__vector
e_12511_scan: ; 0289
_12406__vector: ; 0289
p_12406_calib: ; 0289

;; 156 : inten = 0		-- Stt minimal ljusstyrka
  clrf    H'1B'

;; 158 : while (pin_b4 == high) loop	-- Loopa tills signal
w_12469_ag: ; 028A
  btfss   H'06',4
w_12469_jb: ; 028B
  goto    w_12469_be
w_12469_bo: ; 028C

;; 159 : 	inten = inten + 1	-- ka ljusstyrkan
  incf    H'1B',f

;; 160 : 	foo = 10 - inten	-- foo r slckt tid
  movf    H'1B',w
  sublw   H'0A'
  movwf   H'11'

;; 163 : 			for inten loop	-- Loopa tnd XXX Detta stycke stter ljusstyrkan XXX
; var H'028:000' _loop_temp_12439
  movf    H'1B',w
  movwf   H'28'
w_14478_ag: ; 0292
  movf    H'28',f
  btfsc   H'03',2
w_14478_jb: ; 0294
  goto    w_14478_be
w_14478_bo: ; 0295

;; 164 : 				pin_b2 = high	-- Stt p IR
  bsf     H'10',2
  call    _6142__vector

;; 165 : 				pin_a3 = high	-- Tnd rd
  bsf     H'0F',3
  call    _5997__vector

  decf    H'28',f
  goto    w_14478_ag
w_14478_be: ; 029B

;; 167 : 			for foo loop	-- Loopa slck
; var H'028:000' _loop_temp_12453
  movf    H'11',w
  movwf   H'28'
w_14505_ag: ; 029D
  movf    H'28',f
  btfsc   H'03',2
w_14505_jb: ; 029F
  goto    w_14505_be
w_14505_bo: ; 02A0

;; 168 : 				pin_b2 = low	-- Slck IR
  bcf     H'10',2
  call    _6142__vector

;; 169 : 				pin_a3 = low	-- Slck rd
  bcf     H'0F',3
  call    _5997__vector

  decf    H'28',f
  goto    w_14505_ag
w_14505_be: ; 02A6

;; 171 : 	asm clrwdt	
  clrwdt  
  goto    w_12469_ag
w_12469_be: ; 02A8

;; 173 : pin_b2 = low
  bcf     H'10',2
  call    _6142__vector

;; 174 : pin_a3 = low
  bcf     H'0F',3
  call    _5997__vector

;; 175 : beep
  call    _12176__vector

;; 176 : delay_100ms(1)
  movlw   H'01'
  call    _9754__vector

;; 177 : beep
  goto    _12176__vector
e_12406_calib: ; 02B0
_12280__vector: ; 02B0

;; 136 : procedure snum(byte in foo) is	-- Visar antalet i foo
; var H'028:000' foo
p_12280_snum: ; 02B0
  movwf   H'28'

;; 137 : while foo > 0 loop
w_12399_ag: ; 02B1
  movf    H'28',w
  sublw   H'00'
  btfsc   H'03',0
w_12399_jb: ; 02B4
  goto    w_12399_be
w_12399_bo: ; 02B5

;; 138 : 	if foo > 9 then	-- Strre n 10?
  movf    H'28',w
  sublw   H'09'
  btfsc   H'03',0
  goto    if_12300_el
if_12300_th: ; 02B9

;; 139 : 		pin_b0 = high	-- Visa tiotal
  bsf     H'10',0
  call    _6084__vector

;; 140 : 		delay_100ms(1)
  movlw   H'01'
  call    _9754__vector

;; 141 : 		pin_b0 = low
  bcf     H'10',0
  call    _6084__vector

;; 142 : 		delay_100ms(3)
  movlw   H'03'
  call    _9754__vector

;; 143 : 		foo = foo - 10
  movlw   H'0A'
  subwf   H'28',w
  movwf   H'28'
  goto    if_12300_by
if_12300_el: ; 02C5

;; 145 : 		pin_b1 = high
  bsf     H'10',1
  call    _6113__vector

;; 146 : 		delay_100ms(1)
  movlw   H'01'
  call    _9754__vector

;; 147 : 		pin_b1 = low
  bcf     H'10',1
  call    _6113__vector

;; 148 : 		delay_100ms(3)
  movlw   H'03'
  call    _9754__vector

;; 149 : 		foo = foo - 1 
  movlw   H'01'
  subwf   H'28',w
  movwf   H'28'
if_12300_by: ; 02D0

;; 151 : 	asm clrwdt
  clrwdt  
  goto    w_12399_ag
w_12399_be: ; 02D2
e_12280_snum: ; 02D2
  return  
_12231__vector: ; 02D3
p_12231_reac: ; 02D3

;; 125 : 	asm bsf port_b,lv	-- Tnd LED
  bsf     H'06',0

;; 126 : 	asm bsf port_b,lh	
  bsf     H'06',1

;; 127 : 	asm bsf port_a,lr	
  bsf     H'05',3

;; 128 : 	beep			-- Pip och vnta
  call    _12176__vector

;; 130 : 	asm bcf port_b,lv	-- Slck LED
  bcf     H'06',0

;; 131 : 	asm bcf port_b,lh	
  bcf     H'06',1

;; 132 : 	asm bcf port_a,lr	
  bcf     H'05',3

;; 133 : 	asm clrwdt
  clrwdt  
e_12231_reac: ; 02DB
  return  
_12176__vector: ; 02DC
p_12176_beep: ; 02DC

;; 114 : 	for 50 loop		-- Ungefr 0,1 sekunder
; var H'02A:000' _loop_temp_12182
  movlw   H'32'
  movwf   H'2A'
f_12182_again: ; 02DE

;; 115 : 		sound
  call    _12134__vector

;; 116 : 		delay_1ms(1)
  movlw   H'01'
  call    _9484__vector

;; 117 : 		sound
  call    _12134__vector

;; 118 : 		delay_1ms(1)
  movlw   H'01'
  call    _9484__vector

  decfsz  H'2A',f
  goto    f_12182_again
e_12176_beep: ; 02E6
  return  
_12134__vector: ; 02E7
p_12134_sound: ; 02E7

;; 104 : 	if spstat == 0 then	-- Denna sats genererar vgen
  movf    H'15',f
  btfss   H'03',2
  goto    if_12140_el
if_12140_th: ; 02EA

;; 105 : 		asm bsf port_b,sp	-- Till
  bsf     H'06',3

;; 106 : 		spstat = 1
  movlw   H'01'
  movwf   H'15'
  goto    if_12140_by
if_12140_el: ; 02EE

;; 108 : 		asm bcf port_b,sp	-- Frn
  bcf     H'06',3

;; 109 : 		spstat = 0
  clrf    H'15'
if_12140_by: ; 02F0
e_12134_sound: ; 02F0
  return  
_12086__vector: ; 02F1
p_12086_avstuds: ; 02F1

;; 094 : 	foo = stat
  movf    H'14',w
  movwf   H'11'

;; 095 : 	while (stat != 0) loop	-- Vnta tills knapparna slpps
w_12110_ag: ; 02F3
  movf    H'14',f
  btfsc   H'03',2
w_12110_jb: ; 02F5
  goto    w_12110_be
w_12110_bo: ; 02F6

;; 096 : 		kkol
  call    _12024__vector

;; 097 : 		asm clrwdt
  clrwdt  
  goto    w_12110_ag
w_12110_be: ; 02F9

;; 099 : 	stat = foo
  movf    H'11',w
  movwf   H'14'

;; 100 : 	delay_100ms(1)		-- Vnta lite
  movlw   H'01'
  goto    _9754__vector
e_12086_avstuds: ; 02FD
_12024__vector: ; 02FD
p_12024_kkol: ; 02FD

;; 081 : stat = 0
  clrf    H'14'

;; 082 : if pin_a0 == low then
  btfsc   H'05',0
  goto    if_12036_by
if_12036_th: ; 0300

;; 083 : 	stat = stat + 2
  movlw   H'02'
  addwf   H'14',f
if_12036_by: ; 0302

;; 085 : if pin_a1 == low then
  btfss   H'05',1
if_12051_th: ; 0303

;; 086 : 	stat = stat + 1
  incf    H'14',f
if_12051_by: ; 0304

;; 088 : if pin_a2 == low then
  btfsc   H'05',2
  goto    if_12066_by
if_12066_th: ; 0306

;; 089 : 	stat = stat + 4
  movlw   H'04'
  addwf   H'14',f
if_12066_by: ; 0308
e_12024_kkol: ; 0308
  return  
_9754__vector: ; 0309

;; 459 : procedure delay_100ms( byte in x = 1 ) is
; var H'02A:000' x
p_9754_delay_100ms: ; 0309
  movwf   H'2A'

;; 460 :    _delay_100us( x, 100, 10 )
  movf    H'2A',w
  movwf   H'2C'
  movlw   H'64'
  movwf   H'2D'
  movlw   H'0A'
  goto    _8966__vector
e_9754_delay_100ms: ; 0310
_9619__vector: ; 0310

;; 447 : procedure delay_10ms( byte in x = 1 ) is
; var H'028:000' x
p_9619_delay_10ms: ; 0310
  movwf   H'28'

;; 448 :    _delay_100us( x, 100, 1 )
  movf    H'28',w
  movwf   H'2C'
  movlw   H'64'
  movwf   H'2D'
  movlw   H'01'
  goto    _8966__vector
e_9619_delay_10ms: ; 0317
_9484__vector: ; 0317

;; 435 : procedure delay_1ms( byte in x = 1 ) is
; var H'02B:000' x
p_9484_delay_1ms: ; 0317
  movwf   H'2B'

;; 436 :    _delay_100us( x, 10, 1 )
  movf    H'2B',w
  movwf   H'2C'
  movlw   H'0A'
  movwf   H'2D'
  movlw   H'01'
  goto    _8966__vector
e_9484_delay_1ms: ; 031E
_8966__vector: ; 031E

;; 283 : procedure _delay_100us( byte in x, byte in y, byte in z ) is
; var H'02C:000' x
; var H'02D:000' y
; var H'02E:000' z
p_8966__delay_100us: ; 031E
  movwf   H'2E'

;; 337 :       var byte minus_one = -1
; var H'02F:000' minus_one
  movlw   H'FFFFFFFF'
  movwf   H'2F'

;; 339 :       var byte xx, yy
; var H'030:000' xx
; var H'031:000' yy

;; 343 :          local loop_x, loop_y, loop_z, loop_w
; const H'326' loop_w

;; 346 :       loop_z:
as_9159_loop_z: ; 0321

;; 349 :          movfw y
  movf    H'2D',w

;; 350 :          movwf yy
  movwf   H'31'

;; 351 :       loop_y:
as_9156_loop_y: ; 0323

;; 354 :          movfw x
  movf    H'2C',w

;; 355 :          movwf xx
  movwf   H'30'

;; 356 :       loop_x:
as_9153_loop_x: ; 0325

;; 358 :          movlw inner_iterations
  movlw   H'17'

;; 360 :       loop_w:
as_9162_loop_w: ; 0326

;; 361 :          addwf minus_one, w
  addwf   H'2F',w

;; 362 :          skpnc
  skpnc   

;; 363 :             goto loop_w
  goto    as_9162_loop_w

;; 366 :          decfsz xx, f
  decfsz  H'30',f

;; 367 :          goto loop_x
  goto    as_9153_loop_x

;; 370 :          decfsz yy, f
  decfsz  H'31',f

;; 371 :          goto loop_y
  goto    as_9156_loop_y

;; 374 :          decfsz z, f
  decfsz  H'2E',f

;; 375 :          goto loop_z
  goto    as_9159_loop_z
e_8966__delay_100us: ; 032F
  return  
_7523__vector: ; 0330
p_7523_sleep: ; 0330

;; 985 :    asm sleep
  sleep   
e_7523_sleep: ; 0331
  return  
_7097__vector: ; 0332

;; 847 : procedure eeprom_put( byte in a, byte in d ) is
; var H'028:000' a
; var H'029:000' d
p_7097_eeprom_put: ; 0332
  movwf   H'29'

;; 851 :       var volatile bit ee_write        at 8 : 1
; var H'008:001' ee_write

;; 852 :       var volatile bit ee_write_enable at 8 : 2
; var H'008:002' ee_write_enable

;; 855 :       x84_eeadr        = a
  movf    H'28',w
  movwf   H'09'

;; 856 :       x84_eedata       = d
  movf    H'29',w
  movwf   H'08'

;; 858 :       status_rp0       = on      -- select page 1
  bsf     H'03',5

;; 859 :       ee_write_enable  = on
  bsf     H'08',2

;; 860 :       x84_eeadr        = 0x55    -- to EECON2
  movlw   H'55'
  movwf   H'09'

;; 861 :       x84_eeadr        = 0xAA    -- to EECON2
  movlw   H'AA'
  movwf   H'09'

;; 862 :       ee_write         = on
  bsf     H'08',1

;; 865 :       while ee_write loop end loop
w_7186_ag: ; 033E
  btfsc   H'08',1
w_7186_bo: ; 033F
  goto    w_7186_ag
w_7186_be: ; 0340

;; 867 :       ee_write_enable = off      -- disable writing to prevent accidental writes
  bcf     H'08',2

;; 868 :       status_rp0      = off      -- back to page 0
  bcf     H'03',5
e_7097_eeprom_put: ; 0342
  return  
_6949__vector: ; 0343

;; 813 : procedure eeprom_get( byte in a, byte out d ) is
; var H'028:000' a
; var H'029:000' d
p_6949_eeprom_get: ; 0343
  movwf   H'29'

;; 817 :       var volatile bit ee_read at 8 : 0
; var H'008:000' ee_read

;; 819 :       x84_eeadr        = a
  movf    H'28',w
  movwf   H'09'

;; 820 :       status_rp0       = on          -- select page 1
  bsf     H'03',5

;; 821 :       ee_read          = on          -- set read bit in EECON1
  bsf     H'08',0

;; 822 :       status_rp0       = off         -- back to page 0
  bcf     H'03',5

;; 823 :       d                = x84_eedata  -- the actual data from eeprom
  movf    H'08',w
  movwf   H'29'
e_6949_eeprom_get: ; 034B
  return  

;; 710 : procedure pin_b3'put( bit in x at _port_b_buffer : 3 ) is
p_6171__pin_b3__put_t: ; 034C
_6171__vector: ; 034C
; var H'010:003' x
p_6171_put: ; 034C

;; 711 :   _port_b_flush
  goto    _5079__vector
e_6171_put: ; 034D

;; 707 : procedure pin_b2'put( bit in x at _port_b_buffer : 2 ) is
p_6142__pin_b2__put_t: ; 034D
_6142__vector: ; 034D
; var H'010:002' x
p_6142_put: ; 034D

;; 708 :    _port_b_flush
  goto    _5079__vector
e_6142_put: ; 034E

;; 704 : procedure pin_b1'put( bit in x at _port_b_buffer : 1 ) is
p_6113__pin_b1__put_t: ; 034E
_6113__vector: ; 034E
; var H'010:001' x
p_6113_put: ; 034E

;; 705 :    _port_b_flush
  goto    _5079__vector
e_6113_put: ; 034F

;; 701 : procedure pin_b0'put( bit in x at _port_b_buffer : 0 ) is
p_6084__pin_b0__put_t: ; 034F
_6084__vector: ; 034F
; var H'010:000' x
p_6084_put: ; 034F

;; 702 :    _port_b_flush
  goto    _5079__vector
e_6084_put: ; 0350

;; 691 : procedure pin_a3'put( bit in x at _port_a_buffer : 3 ) is
p_5997__pin_a3__put_t: ; 0350
_5997__vector: ; 0350
; var H'00F:003' x
p_5997_put: ; 0350

;; 692 :    _port_a_flush
  goto    _5056__vector
e_5997_put: ; 0351
_5079__vector: ; 0351
p_5079__port_b_flush: ; 0351

;; 590 :    var volatile byte port_b at 6 = _port_b_buffer
; var H'006:000' port_b
  movf    H'10',w
  movwf   H'06'
e_5079__port_b_flush: ; 0353
  return  
_5056__vector: ; 0354
p_5056__port_a_flush: ; 0354

;; 587 :    var volatile byte port_a at 5 = _port_a_buffer
; var H'005:000' port_a
  movf    H'0F',w
  movwf   H'05'
e_5056__port_a_flush: ; 0356
  return  

;; 410 : procedure pin_b7_direction'put( bit in d at trisb : 7 ) is
p_3546__pin_b7_direction__put_t: ; 0357
_3546__vector: ; 0357
; var H'00E:007' d
p_3546_put: ; 0357

;; 411 :    _trisb_flush
  goto    _2785__vector
e_3546_put: ; 0358

;; 407 : procedure pin_b6_direction'put( bit in d at trisb : 6 ) is
p_3517__pin_b6_direction__put_t: ; 0358
_3517__vector: ; 0358
; var H'00E:006' d
p_3517_put: ; 0358

;; 408 :    _trisb_flush
  goto    _2785__vector
e_3517_put: ; 0359

;; 404 : procedure pin_b5_direction'put( bit in d at trisb : 5 ) is
p_3488__pin_b5_direction__put_t: ; 0359
_3488__vector: ; 0359
; var H'00E:005' d
p_3488_put: ; 0359

;; 405 :    _trisb_flush
  goto    _2785__vector
e_3488_put: ; 035A

;; 401 : procedure pin_b4_direction'put( bit in d at trisb : 4 ) is
p_3459__pin_b4_direction__put_t: ; 035A
_3459__vector: ; 035A
; var H'00E:004' d
p_3459_put: ; 035A

;; 402 :    _trisb_flush
  goto    _2785__vector
e_3459_put: ; 035B

;; 398 : procedure pin_b3_direction'put( bit in d at trisb : 3 ) is
p_3430__pin_b3_direction__put_t: ; 035B
_3430__vector: ; 035B
; var H'00E:003' d
p_3430_put: ; 035B

;; 399 :    _trisb_flush
  goto    _2785__vector
e_3430_put: ; 035C

;; 395 : procedure pin_b2_direction'put( bit in d at trisb : 2 ) is
p_3401__pin_b2_direction__put_t: ; 035C
_3401__vector: ; 035C
; var H'00E:002' d
p_3401_put: ; 035C

;; 396 :    _trisb_flush
  goto    _2785__vector
e_3401_put: ; 035D

;; 392 : procedure pin_b1_direction'put( bit in d at trisb : 1 ) is
p_3372__pin_b1_direction__put_t: ; 035D
_3372__vector: ; 035D
; var H'00E:001' d
p_3372_put: ; 035D

;; 393 :    _trisb_flush
  goto    _2785__vector
e_3372_put: ; 035E

;; 389 : procedure pin_b0_direction'put( bit in d at trisb : 0 ) is
p_3343__pin_b0_direction__put_t: ; 035E
_3343__vector: ; 035E
; var H'00E:000' d
p_3343_put: ; 035E

;; 390 :    _trisb_flush
  goto    _2785__vector
e_3343_put: ; 035F

;; 376 : procedure pin_a4_direction'put( bit in d at trisa : 4 ) is
p_3250__pin_a4_direction__put_t: ; 035F
_3250__vector: ; 035F
; var H'00D:004' d
p_3250_put: ; 035F

;; 377 :    _trisa_flush
  goto    _2764__vector
e_3250_put: ; 0360

;; 373 : procedure pin_a3_direction'put( bit in d at trisa : 3 ) is
p_3221__pin_a3_direction__put_t: ; 0360
_3221__vector: ; 0360
; var H'00D:003' d
p_3221_put: ; 0360

;; 374 :    _trisa_flush
  goto    _2764__vector
e_3221_put: ; 0361

;; 370 : procedure pin_a2_direction'put( bit in d at trisa : 2 ) is
p_3192__pin_a2_direction__put_t: ; 0361
_3192__vector: ; 0361
; var H'00D:002' d
p_3192_put: ; 0361

;; 371 :    _trisa_flush
  goto    _2764__vector
e_3192_put: ; 0362

;; 367 : procedure pin_a1_direction'put( bit in d at trisa : 1 ) is
p_3163__pin_a1_direction__put_t: ; 0362
_3163__vector: ; 0362
; var H'00D:001' d
p_3163_put: ; 0362

;; 368 :    _trisa_flush
  goto    _2764__vector
e_3163_put: ; 0363

;; 364 : procedure pin_a0_direction'put( bit in d at trisa : 0 ) is
p_3134__pin_a0_direction__put_t: ; 0363
_3134__vector: ; 0363
; var H'00D:000' d
p_3134_put: ; 0363

;; 365 :    _trisa_flush
  goto    _2764__vector
e_3134_put: ; 0364
_2785__vector: ; 0364
p_2785__trisb_flush: ; 0364

;; 305 :       bank movfw trisb
  movf    H'0E',w

;; 306 :            tris  6
  tris    H'06'
e_2785__trisb_flush: ; 0366
  return  
_2764__vector: ; 0367
p_2764__trisa_flush: ; 0367

;; 298 :       bank movfw trisa
  movf    H'0D',w

;; 299 :            tris  5
  tris    H'05'
e_2764__trisa_flush: ; 0369
  return  

 END

; ********** variable mapping
; 03:0 : ;
;   status                         * 0040:19 jpic.jal 
; 03:5 : ;
;   status_rp0                     * 0130:19 jpic.jal 
; 05:0 : ;
;   port_a                         * 0587:22 jpic.jal 
;   pin_a0                         * 0086:19 jpic.jal 
;   port_a                         * 0042:19 jpic.jal 
; 05:1 : ;
;   pin_a1                         * 0087:19 jpic.jal 
; 05:2 : ;
;   pin_a2                         * 0088:19 jpic.jal 
; 06:0 : ;
;   port_b                         * 0590:22 jpic.jal 
;   port_b                         * 0043:19 jpic.jal 
; 06:4 : ;
;   pin_b4                         * 0097:19 jpic.jal 
; 08:0 : ;
;   ee_read                        * 0817:24 jpic.jal 
;   x84_eedata                     * 0047:19 jpic.jal 
; 08:1 : ;
;   ee_write                       * 0851:24 jpic.jal 
; 08:2 : ;
;   ee_write_enable                * 0852:24 jpic.jal 
; 09:0 : ;
;   x84_eeadr                      * 0048:19 jpic.jal 
; 0C:0 : ;
;    transfer_byte                   
;    transfer_bit                    
; 0D:0 : ;
;   d                              * 0364:33 jpic.jal 
;   trisa                            0276:10 jpic.jal 
; 0D:1 : ;
;   d                              * 0367:33 jpic.jal 
; 0D:2 : ;
;   d                              * 0370:33 jpic.jal 
; 0D:3 : ;
;   d                              * 0373:33 jpic.jal 
; 0D:4 : ;
;   d                              * 0376:33 jpic.jal 
; 0E:0 : ;
;   d                              * 0389:33 jpic.jal 
;   trisb                            0277:10 jpic.jal 
; 0E:1 : ;
;   d                              * 0392:33 jpic.jal 
; 0E:2 : ;
;   d                              * 0395:33 jpic.jal 
; 0E:3 : ;
;   d                              * 0398:33 jpic.jal 
; 0E:4 : ;
;   d                              * 0401:33 jpic.jal 
; 0E:5 : ;
;   d                              * 0404:33 jpic.jal 
; 0E:6 : ;
;   d                              * 0407:33 jpic.jal 
; 0E:7 : ;
;   d                              * 0410:33 jpic.jal 
; 0F:0 : ;
;   _port_a_buffer                   0580:10 jpic.jal 
; 0F:3 : ;
;   x                              * 0691:23 jpic.jal 
; 10:0 : ;
;   x                              * 0701:23 jpic.jal 
;   _port_b_buffer                   0581:10 jpic.jal 
; 10:1 : ;
;   x                              * 0704:23 jpic.jal 
; 10:2 : ;
;   x                              * 0707:23 jpic.jal 
; 10:3 : ;
;   x                              * 0710:23 jpic.jal 
; 11:0 : ;
;   foo                              0044:10 kvf.jal 
; 12:0 : ;
;   bar                              0045:10 kvf.jal 
; 13:0 : ;
;   tcont                            0047:10 kvf.jal 
; 14:0 : ;
;   stat                             0049:10 kvf.jal 
; 15:0 : ;
;   spstat                           0050:10 kvf.jal 
; 16:0 : ;
;   delstartmain                     0051:10 kvf.jal 
; 17:0 : ;
;   delstart                         0052:10 kvf.jal 
; 18:0 : ;
;   signum                           0054:10 kvf.jal 
; 19:0 : ;
;   sps                              0055:10 kvf.jal 
; 1A:0 : ;
;   scantime                         0056:10 kvf.jal 
; 1B:0 : ;
;   inten                            0057:10 kvf.jal 
; 1C:0 : ;
;   aset                             0058:10 kvf.jal 
; 1D:0 : ;
;   act                              0059:10 kvf.jal 
; 1E:0 : ;
;   count                            0060:10 kvf.jal 
; 1F:0 : ;
;   amar                             0061:10 kvf.jal 
; 20:0 : ;
;   siglen                           0062:10 kvf.jal 
; 21:0 : ;
;   tres                             0065:10 kvf.jal 
; 22:0 : ;
;   adelay                           0066:10 kvf.jal 
; 23:0 : ;
;   sigen                            0067:10 kvf.jal 
; 24:0 : ;
;   inter                            0069:10 kvf.jal 
; 25:0 : ;
;   antal                            0070:10 kvf.jal 
; 26:0 : ;
;   ljud                             0071:10 kvf.jal 
; 27:0 : ;
;   sdel                             0072:10 kvf.jal 
; 28:0 : ;
;   a                                0813:23 jpic.jal 
;   a                                0847:23 jpic.jal 
;   x                                0447:23 jdelay.jal 
;   foo                              0136:16 kvf.jal 
;   _loop_temp_12453                 0167:04 kvf.jal 
;   _loop_temp_12439                 0163:04 kvf.jal 
;   _loop_temp_12542                 0186:01 kvf.jal 
;   _loop_temp_12655                 0214:01 kvf.jal 
;   foo                              0255:16 kvf.jal 
;   _loop_temp_13705                 0395:02 kvf.jal 
; 29:0 : ;
;   d                                0813:34 jpic.jal 
;   d                                0847:34 jpic.jal 
;   _loop_temp_12548                 0188:01 kvf.jal 
;   _loop_temp_12717                 0231:02 kvf.jal 
;   _loop_temp_12659                 0215:02 kvf.jal 
;   _loop_temp_12831                 0256:02 kvf.jal 
; 2A:0 : ;
;   x                                0459:24 jdelay.jal 
;   _loop_temp_12182                 0114:02 kvf.jal 
;   _loop_temp_12617                 0201:02 kvf.jal 
;   _loop_temp_12554                 0190:02 kvf.jal 
;   _loop_temp_12677                 0220:03 kvf.jal 
;   _loop_temp_12663                 0216:03 kvf.jal 
; 2B:0 : ;
;   x                                0435:22 jdelay.jal 
; 2C:0 : ;
;   x                                0283:25 jdelay.jal 
; 2D:0 : ;
;   y                                0283:36 jdelay.jal 
; 2E:0 : ;
;   z                                0283:47 jdelay.jal 
; 2F:0 : ;
;   minus_one                        0337:16 jdelay.jal 
; 30:0 : ;
;   xx                               0339:16 jdelay.jal 
; 31:0 : ;
;   yy                               0339:20 jdelay.jal 

